#
# Copyright (c) 2001 by Sun Microsystems, Inc. All rights reserved.
#
#  @version      "@(#)wci-fmconf-d.x  1.50   03/09/16 SMI"
#  @author       John Ackerley and John Jamberdino
#  @description  WildCat Fabric Configuration Module
#

[ use MANAGED-MODULE ]
[ load wci-fmconf-m.x ]
[ requires package wcifmconf ]
[ requires template wci-fmconf-models-d ]
[ requires template wci-fmconf-commands-j ]

#
# Define services required by this module
#
_services = { [ use SERVICE ]
	#
	# Standard Bourne Shell
	#
	sh = {
            command     = "pipe://localhost//bin/sh;transport=shell"
	    max		= 2
	}
}

#
# Define procedures required by this module
#
_procedures = { [ use PROC ]
	[ source wci-fmconf-d.prc ]
}

# Allow for the WildMan GUI to be accessed from a right click on the module.
#consoleHint:commands               	= wci-fmconf
#consoleHint:commandLabel(wci-fmconf)	= "WCI Fabric Manager Application...."
#consoleHint:commandSpec(wci-fmconf)	 = launchApp com.sun.symon.apps.wci.fmconf.console.presentation.SMFmConfFrame "Add a String"

consoleHint:mediumDesc               	= base.modules.wci-fmconf:moduleDetail

[ use _procedures ]

deactivateActions(pre) = cleardot daqcache
deactivateService(cleardot) = _self
deactivateCommand(cleardot) = deleteDOTEntries %[ valueOf fmDiscovery.discoveryTableName.0 ]
deactivateService(daqcache) = _internal
deactivateCommand(daqcache) = freeFMConfData

fm = { [ use templates.wci-fmconf-models-d.fm ]

	properties = {

		modInstance = {

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = setValue 0 %instance

		}

		agentPort = { [ use _procedures ]

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = getAgentPort

		}

		name = { [ use _procedures ]

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = setFmConfData /var/opt/SUNWsymon/cfg/wci-fmconf-sv-%[ valueOf fm.properties.modInstance.0 ].dat 1 %i18nFabricName

		}

		server = { [ use _procedures ]

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = setFmConfData /var/opt/SUNWsymon/cfg/wci-fmconf-sv-%[ valueOf fm.properties.modInstance.0 ].dat 2 [ info hostname ]

		}

		port = { [ use _procedures ]

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = setFmConfData /var/opt/SUNWsymon/cfg/wci-fmconf-sv-%[ valueOf fm.properties.modInstance.0 ].dat 3 %fmPort

		}

		status = { [ use _procedures ]

			type			= derived
			refreshTrigger		= fm.properties.name:set
			refreshService		= _services.sh
			refreshCommand		= fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getFmStatus sfluser
			refreshInterval		= 7200
			initInterval = 5

		}

		version = { [ use _procedures ]

			type			= derived
			refreshTrigger		= fm.properties.status:refresh
			refreshService		= _services.sh
			refreshCommand		= fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getFmVersion sfluser
			refreshInterval		= 7200
			initInterval = 10
			
		}

		daqLogName = {

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = setValue 0 /var/opt/SUNWsymon/log/fmdaq.log

		}

		daqLogSize = { 

			type			= active
			refreshService		= _internal
			refreshCommand		= file size %[ valueOf fm.properties.daqLogName.0 ]
			refreshInterval		= 3600
			initInterval = 10

		}

		fabricXMLFilePath = {

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = setValue 0 /none

			type = active
			refreshService  = _services.sh
			refreshCommand  = getFMXMLFilePath.sh %[ valueOf fm.properties.name.0 ]
			refreshInterval = 7200
			initInterval = 20

		}

		fabricXMLFileModTime = { [ use _procedures ]

			activateActions(post) = setDefaultValue
			activateService(setDefaultValue) = _internal
			activateCommand(setDefaultValue) = getFmConfData /var/opt/SUNWsymon/cfg/wci-fmconf-sv-%[ valueOf fm.properties.modInstance.0 ].dat 4

			type = derived
			refreshTrigger = fm.properties.fabricXMLFilePath:refresh fm.properties.fabricXMLFileModTrigger:set
			refreshService  = _internal
			refreshCommand  = getAndSetFmXMLFileModTime /var/opt/SUNWsymon/cfg/wci-fmconf-sv-%[ valueOf fm.properties.modInstance.0 ].dat 4
			refreshInterval = 0
			initInterval = 25

		}

		fabricXMLFileModStatus = { [ use _procedures ]

			type = derived
			refreshTrigger = fm.properties.fabricXMLFilePath:refresh
			refreshService  = _internal
			refreshCommand  = getFmXMLFileStatus /var/opt/SUNWsymon/cfg/wci-fmconf-sv-%[ valueOf fm.properties.modInstance.0 ].dat 4
			refreshInterval = 600
			initInterval = 35

		}

	}

	fabricInfo = {

		partitionTable = {

			type = derived
			refreshTrigger = fm.properties.fabricXMLFilePath:refresh fm.properties.fabricXMLFileModStatus:status fm.properties.fabricXMLFileModTime:refresh
			refreshService = _internal
			refreshCommand = getFMPartitionData %[ valueOf fm.properties.name.0 ] %[ valueOf fm.properties.fabricXMLFilePath.0 ]
			refreshInterval = 0
			initInterval = 40

		}

		memberTable = {

			type = derived
			refreshTrigger = fm.fabricInfo.partitionTable:refresh
			refreshService = _internal
			refreshCommand = getFMMemberData		
		}

		linkTable = {

			type = derived
			refreshTrigger = fm.fabricInfo.partitionTable:refresh
			refreshService = _internal
			refreshCommand = getFMLinkData

		}		

	}

}


fmsio = { [ use templates.wci-fmconf-models-d.fmsio ]
		[ use templates.wci-fmconf-commands-j.fmsio ]
		[ use _procedures ]
	consoleHint:hidden 	= true

	adhocCommand(GetFabricsList) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getFabricsList \[ getUserName \]

	adhocCommand(GetFabricObject) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getFabricObject \[ getUserName \]

        adhocCommand(GetFileList) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getFileList \[ getUserName \]

        adhocCommand(GetTextFile) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getTextFile \[ getUserName \]

        adhocCommand(SaveTextFile) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] saveTextFile \[ getUserName \]

        adhocCommand(ApplyCfgToFab) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] applyCfgToFab \[ getUserName \]

	adhocCommand(CreatePartition) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] createPartition \[ getUserName \]

	adhocCommand(DeletePartition) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] deletePartition \[ getUserName \]

	adhocCommand(UpgradePartitionMap)        = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] upgradePartitionMap \[ getUserName \]

	adhocCommand(UpgradePartitionList)     = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] upgradePartitionList \[ getUserName \]

	adhocCommand(UpgradePartitionStripe)     = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] upgradePartitionStripe \[ getUserName \]

	adhocCommand(DowngradePartition)     = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] downgradePartition \[ getUserName \]

	adhocCommand(UpdateNodes)     = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] updateNodes \[ getUserName \]

	adhocCommand(UpdateNodeProperties)     = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] updateNodeProperties \[ getUserName \]

	adhocCommand(UpdateNodeNCSlices)     = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] updateNodeNCSlices \[ getUserName \]

	adhocCommand(UpdatePartition)     = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] updatePartition \[ getUserName \]

	adhocCommand(StartDiscovery) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] startDiscovery \[ getUserName \]

	adhocCommand(IsDiscoveryDone) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] isDiscoveryDone \[ getUserName \]

	adhocCommand(StopDiscovery) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] stopDiscovery \[ getUserName \]

	adhocCommand(GetDiscoveryData) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getDiscoveryData \[ getUserName \]

	adhocCommand(GetWciInventory) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] getWciInventory \[ getUserName \]

        adhocCommand(AddNodeToFabric) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] addNodeToFabric \[ getUserName \]

        adhocCommand(RemNodeFromFabric) = probeserver -u root -c fmcmd %[ valueOf fm.properties.server.0 ] %[ valueOf fm.properties.port.0 ] %[ valueOf fm.properties.name.0 ] remNodeFromFabric \[ getUserName \]

}

fmDiscovery = { [ use templates.wci-fmconf-models-d.fmDiscovery ]

	discoveryTableName = { [ use _procedures ]
	
		activateActions(post) = setDefaultValue
		activateService(setDefaultValue) = _internal
		activateCommand(setDefaultValue) = setValue 0 none

		type			= derived
		refreshTrigger		= fm.fabricInfo.memberTable:refresh
		refreshService		= _internal
		refreshCommand		= refreshDiscoveryObjectTable

	}

	discoveryTableNum = {
	
		activateActions(post) = setDefaultValue
		activateService(setDefaultValue) = _internal
		activateCommand(setDefaultValue) = setValue 0 0

	}

}


[ load wci-fmconf-d.def ]




